import matplotlib.pyplot as plt
from matplotlib import cm
import numpy as np

Nmax=5000
Long=100
Larg=100
tol=.01
Thaut=0
Tbas=0
Tgauche=100
Tdroit=100
valinit=50
plt.clf()

Temp=np.ones((Larg,Long))*valinit
Temp[0,1:(Long-1)]=Thaut
Temp[-1,1:(Long-1)]=Tbas
Temp[:,0]=Tgauche
Temp[:,-1]=Tdroit
Temp0=Temp.copy()

iteration=0
err=tol+1

while (err>tol) and (iteration<Nmax):
	for i in range(1,Larg-1):
		for j in range(1,Long-1):
			Temp[i,j]=.25*(Temp0[i+1,j]+Temp[i-1,j]+Temp[i,j-1]+Temp0[i,j+1])  
	iteration=iteration+1
	err=np.amax(Temp0-Temp)
	Temp0=Temp.copy()
print('convergence à ',iteration,' itérations')
plt.imshow(Temp,cmap=cm.hot)
#plt.imshow(Temp,cmap=cm.bwr)
#plt.imshow(Temp)
plt.colorbar()
plt.xlabel('x',fontsize=14)
plt.ylabel('y',fontsize=14)
plt.title('Température dans une plaque en régime stationnaire')
#plt.axis('tight') #configure la taille des axes de manière à voir l'ensemble des données
plt.show()
